#
# spec file for package gxdview (Version 1.18.1.1)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           gxdview
BuildRequires:  gcc-c++ xorg-x11-devel
License:        GPL v2 or later
Group:          Productivity/Publishing/Troff
AutoReqProv:    on
Requires:       groff
Conflicts:      jgxdview
Version:        1.18.1.1
Release:        154
Summary:        Ditroff Output Displayer for Groff
Url:            http://www.gnu.org/software/groff/groff.html
Source0:        ftp://ftp.gnu.org/gnu/groff/groff-1.18.1.1.tar.bz2
Source1:        SuSEconfig.groff
Source2:        sysconfig.suseconfig-groff
Source3:        groff.sh
Source4:        groff.csh
Patch0:         groff_1.18.1.1-1-debian.diff.bz2
Patch1:         suse.patch
Patch2:         pic-html.patch
Patch3:         gcc4.patch
Patch4:         groff-1.17.2-gcc3.patch
Patch5:         utf8.patch
Patch6:         debian-fix.patch
Patch7:         double-free.patch
Patch8:         groffer-security.patch
Patch9:         groff-1.18.1.1-gcc41.patch
Patch10:        bugzilla-217106-too-few-arguments-in-function-call.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
This version of xditview is called gxditview and has some extensions
used by the groff command.  gxditview is used by groff if called with
the -X option.



Authors:
--------
    James Clark     <jjc@clark.com>

%prep
%setup -q -n groff-%{version} 
%patch0 -p1 -b .debian
%patch1 -p1 -b .suse
%patch2 -p1 -b .pic-html
%patch3 -p1 -b .gcc4
%patch4 -p1 -b .gcc3
%patch5 -p1 -b .utf-8
%patch6 -p1 -b .debian-fix
%patch7
%patch8 -p1
%patch9 -p1
%patch10 -p1

%build
# remove empty backups
rm -f ChangeLog.jp.debian README.jp.debian
#
PATH=$PWD/src/roff/troff:$PWD/src/preproc/pic:$PWD/src/preproc/eqn:$PWD/src/preproc/tbl:$PWDsrc/preproc/refer:$PWD/src/preproc/soelim:$PATH
PATH=$PWD/src/roff/grog:$PWD/src/roff/groff:$PWD/src/devices/grops:$PWD/src/devices/grotty:$PWD/src/devices/grodvi:$PWD/src/devices/grohtml:$PATH
GROFF_COMMAND_PREFIX=
GROFF_FONT_PATH=$PWD
GROFF_TMAC_PATH=$PWD/tmac:$PWD/src/roff/troff
export PATH GROFF_COMMAND_PREFIX GROFF_FONT_PATH GROFF_TMAC_PATH
#
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing" INSTALL_PROGRAM='${INSTALL}'
./configure --prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} --enable-multibyte
pushd src/xditview
    xmkmf -a
    make depend && make CDEBUGFLAGS="$RPM_OPT_FLAGS" NIPPONDEFINES="-DNIPPON"
popd

%install
if [ ! "x" = "x$RPM_BUILD_ROOT" ] ; then
   install -d -m755 $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT/usr/share
mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT%{_defaultdocdir}/groff
mkdir -p $RPM_BUILD_ROOT%{_infodir}
make -C src/xditview install DESTDIR=$RPM_BUILD_ROOT
make -C src/xditview install.man MANSUFFIX=1 LIBMANSUFFIX=3 DESTDIR=$RPM_BUILD_ROOT

%clean
#[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root)
#
# Should we make a own package gxditview?
# ... but the new xditview is a good program for X11R6.3.
# If gxditview is required GXDITVIEW should be set
# in groff/groff.cc to "gxditview"
#
# Yes we should make a own package because groff uses
# some features of gxditview which xditview doesn't know.
#
%{_bindir}/gxditview
%doc %{_mandir}/man1/gxditview.1*
%config %{_datadir}/X11/app-defaults/GXditview

%changelog
* Sun Feb 11 2007 ro@suse.de
- added defattr
* Wed Jan 17 2007 mfabian@suse.de
- Bugzilla #217106: too few arguments in function call.
* Tue Jan 02 2007 mfabian@suse.de
- Bugzilla #230030: make Russian and Czech man-pages display
  correctly again in UTF-8 locales (has been broken by the
  update to man-2.4.3).
* Tue Sep 05 2006 rguenther@suse.de
- Split from groff spec file.
